###RɂStan
#C++̃RpCƘAgRtools𓱓ĂƂ܂B
#RtoolsɊւẮAڂ͎WEBy[WB
#https://github.com/stan-dev/rstan/wiki/Rstan-Getting-Started-%28Japanese%29

#rstañCXg[
install.packages("rstan", dependencies = TRUE)

###Xg`
x <- c(1,2,3)#3̃xNg`
Y <- matrix(c(1,2,3,4),2,2)#2~2̍s`

#zƂXgxY
(z <- list(a=x,b=Y)) #xNgɂaAsɂbƂIuWFNgt


###`Af
#f[^̍Əꏊw聦ꏊ͊eŕύXĂ
#tH_̋؂́h/hł邱Ƃɒ
setwd("C:/Users/xxx/xxx")
#Əꏊɂf[^ǂݍ܂
Data <- read.csv("Data1.csv")

#TvETCY
n <- nrow(Data)
#ϐxNg
y <- Data[,"IDx"]
#ϐs񁦂ł͐ؕЂ܂
X <- cbind(1,Data[,"N"],Data[,""])    
#ΉAWxNg̎ؕЂ̐܂
m <- ncol(X)
#XgƂĂ܂Ƃ߂
#(TvETCYAΉAWxNg̎AϐxNgAϐs)
data_list <- list(n=n,m=m,y=y,X=X)

#`AStañR[h
LinearRegression <-'
 //dataubN
	data{
		int<lower=0> n;//TvETCY
		int<lower=0> m;//ϐ̐ؕЂ܂
		vector[n] y;//ϐxNg
		matrix[n,m] X;//ϐs񁦐ؕЂ܂
	}
// parametersubN
	parameters{
		vector[m] beta;//ΉAWp[^ؕЂ܂
		real<lower=0> sigma2;//덷̕U(XJ[)
	}
//modelubN
	model{
		beta~normal(0,sqrt(1000));//beta̎Oz
		sigma2~inv_gamma(0.001,0.001);//sigma2̎Oz
		y~normal(X*beta,sqrt(sigma2));//y̖ޓx֐
	}
'

#StaňĂяo
library(rstan)
rstan_options(auto_write = TRUE)
options(mc.cores = parallel::detectCores())

#Stan̎s
fit <- stan(model_code=LinearRegression,data=data_list,iter=1000,chains=4)

#R\[ɏo
print(fit)

#Otŏo
pairs(fit)

#R̃IuWFNgւ̎󂯓n
out <- extract(fit, permuted=TRUE)


###WXeBbNAf
###f̐}
#WXeBbNAf̊֐`
p_i <- function(v_i) 1/(1+exp(-v_i))
#֐̃vbg
plot(p_i,-5,5,xlab="v_i",ylab="p_i")
#⏕̕`
abline(h=1,lty=2);abline(h=0,lty=2);abline(v=0,lty=2)

#f[^̍Əꏊw聦ꏊ͊eŕύXĂB
setwd("C:/Users/xxx/xxx")
#Əꏊɂf[^ǂݍ܂
Data <- read.csv("Data2.csv")
#͗pf[^̍쐬
#TvETCY
n <- nrow(Data)
#ϐis=1,sȂ=0j
y <- Data[,"X̗p"]
#ϐs񁦐ؕЂ܂
X <- cbind(1,Data[,"N"],Data[,""])
#ΉAW̐ؕЂ܂
m <- ncol(X)
#XgƂĂ܂Ƃ߂
data_list <- list(n=n,m=m,y=y,X=X)

#StañR[h
LogisticRegression <- '
	data{
	   int<lower=0> n;//TvETCY
	   int<lower=0> m;//ϐ̐
	   int<lower=0,upper=1> y[n];//ϐ̔z
	   matrix[n,m] X;//ϐs
	}
	parameters{
	   vector[m] beta;//ΉAWxNg
	}
	model{
	   beta~normal(0,sqrt(1000));//beta̎Oz
	   y ~ bernoulli_logit(X*beta);//ޓx֐
	}
'

#model͎̕ł悢
#for (i in 1:n)
#y[i] ~ bernoulli_logit(X[i]*beta);

library(rstan)
rstan_options(auto_write = TRUE)
options(mc.cores = parallel::detectCores())

#Stan̎s
fit <- stan(model_code=LogisticRegression,data=data_list,iter=1000,chains=4)

#ʂ̕\
print(fit)
